searchNodes=[{"doc":"Various small utilities.Semaphore, a simple semaphore implementationCountDown, a simple countdown latchBlockingQueue, a simple queue suitable for producer/consumer scenario","ref":"Alambic.html","title":"Alambic","type":"module"},{"doc":"Interface to a blocking collection.A blocking collection is a collection of items where:multiple processes can push data into the collecionmultiple processes can consume items from the collectiona blocking collection may be &quot;completed&quot; meaning it will not accept any more items.getting data blocks until some data is availbale or the collection is &quot;omplete&quot; (will not receive any more data)putting data may block until some room is available in the collection for more data (blocking collections can either accept unlimited amount of items or limit the number of items they can hold)BlockingCollection also implements the Enumerable protocol and using functions from the Enum and Stream module is the preferred way of consuming a blocking collection. Enumerating a blocking collection will consume its items, so if multiple processes are enumerating a blocking collection at the same time, they will only see a subset of the items added to the collection.","ref":"Alambic.BlockingCollection.html","title":"Alambic.BlockingCollection","type":"protocol"},{"doc":"Add an item to the collection. May block until some room is available in the collection.Return :ok if adding was successful, :error if some internal error occured or the collection does not accept items any more.","ref":"Alambic.BlockingCollection.html#add/2","title":"Alambic.BlockingCollection.add/2","type":"function"},{"doc":"Put the collection in the completed state, where it will not accept any more items but will serve those currently inside the collection.","ref":"Alambic.BlockingCollection.html#complete/1","title":"Alambic.BlockingCollection.complete/1","type":"function"},{"doc":"Return the number of items in the collection.","ref":"Alambic.BlockingCollection.html#count/1","title":"Alambic.BlockingCollection.count/1","type":"function"},{"doc":"Get an item from the collection. If no item is available, will block until an item is available or the collection has been completed.Return:{:ok, item} when an item is available:completed when the collection has been completed:error if some error occurred","ref":"Alambic.BlockingCollection.html#take/1","title":"Alambic.BlockingCollection.take/1","type":"function"},{"doc":"Try to add an item in the collection. Will return true if the item was added, false if the collection cannot accept items at the moment.","ref":"Alambic.BlockingCollection.html#try_add/2","title":"Alambic.BlockingCollection.try_add/2","type":"function"},{"doc":"Try to get an item from the collection. Do not block.Return:{true, item} if some item was found{false, reason} if not item could be returned. reason maybe::completed if the collection is completed:error if an error occurred:empty if the collection is currenlty empty","ref":"Alambic.BlockingCollection.html#try_take/1","title":"Alambic.BlockingCollection.try_take/1","type":"function"},{"doc":"","ref":"Alambic.BlockingCollection.html#t:t/0","title":"Alambic.BlockingCollection.t/0","type":"type"},{"doc":"Mixin for Collectable implementation in blocking collections.","ref":"Alambic.BlockingCollection.Collectable.html","title":"Alambic.BlockingCollection.Collectable","type":"module"},{"doc":"Mixin for Enumerable implementation in blocking collections.","ref":"Alambic.BlockingCollection.Enumerable.html","title":"Alambic.BlockingCollection.Enumerable","type":"module"},{"doc":"A queue hosted in a process so that other processes can access it concurrently. It implements the BlockingCollection protocol. Enumerating a BlockingQueue will consumes it content. Enumeration only complete when the BlockingQueue is empty and BlockingQueue.complete/1 has been called on the BlockingQueue.It is implemented as a GenServer.If you need to start a named BlockingQueue as part of a supervision tree, you can directly use the GenServer.start/start_link functions.","ref":"Alambic.BlockingQueue.html","title":"Alambic.BlockingQueue","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Alambic.BlockingQueue.html#child_spec/1","title":"Alambic.BlockingQueue.child_spec/1","type":"function"},{"doc":"Signal the collection will no longer accept items.Exampleiex&gt; q = Alambic.BlockingQueue.create() iex&gt; :ok = Alambic.BlockingQueue.complete(q) iex&gt; :completed = Alambic.BlockingQueue.dequeue(q) iex&gt; {false, :completed} = Alambic.BlockingQueue.try_dequeue(q) iex&gt; Alambic.BlockingQueue.enqueue(q, :item) :error","ref":"Alambic.BlockingQueue.html#complete/1","title":"Alambic.BlockingQueue.complete/1","type":"function"},{"doc":"Return the number of items in the queue.Exampleiex&gt; q = Alambic.BlockingQueue.create() iex&gt; 0 = Alambic.BlockingQueue.count(q) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data) iex&gt; Alambic.BlockingQueue.count(q) 3","ref":"Alambic.BlockingQueue.html#count/1","title":"Alambic.BlockingQueue.count/1","type":"function"},{"doc":"Create a BlockingQueue with a given limit on the numbers of items it can contain.Exampleiex&gt; %Alambic.BlockingQueue{id: pid} = Alambic.BlockingQueue.create() iex&gt; is_pid(pid) true","ref":"Alambic.BlockingQueue.html#create/1","title":"Alambic.BlockingQueue.create/1","type":"function"},{"doc":"Create a BlockingQueue linked to the current process.Exampleiex&gt; %Alambic.BlockingQueue{id: pid} = Alambic.BlockingQueue.create_link() iex&gt; is_pid(pid) true","ref":"Alambic.BlockingQueue.html#create_link/1","title":"Alambic.BlockingQueue.create_link/1","type":"function"},{"doc":"Dequeue one item from the queue. If no item is available, will wait until some data is available.Exampleiex&gt; q = Alambic.BlockingQueue.create() iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data1) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data2) iex&gt; Alambic.BlockingQueue.dequeue(q) {:ok, :data1}","ref":"Alambic.BlockingQueue.html#dequeue/1","title":"Alambic.BlockingQueue.dequeue/1","type":"function"},{"doc":"Destroy a BlockingQueue, losing all its current messages.Exampleiex&gt; queue = Alambic.BlockingQueue.create iex&gt; Alambic.BlockingQueue.destroy(queue) :ok","ref":"Alambic.BlockingQueue.html#destroy/1","title":"Alambic.BlockingQueue.destroy/1","type":"function"},{"doc":"Enqueue some value. If the queue currently contains the maximum number of elements allowed, it will block until at least one item has been consumed.Exampleiex&gt; q = Alambic.BlockingQueue.create() iex&gt; Alambic.BlockingQueue.enqueue(q, :some_data) :ok","ref":"Alambic.BlockingQueue.html#enqueue/2","title":"Alambic.BlockingQueue.enqueue/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Alambic.BlockingQueue.html#init/1","title":"Alambic.BlockingQueue.init/1","type":"function"},{"doc":"Try to dequeue some data from the queue. If one item is available {true, item} is returned, false otherwise.Exampleiex&gt; q = Alambic.BlockingQueue.create() iex&gt; {false, :empty} = Alambic.BlockingQueue.try_dequeue(q) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :data) iex&gt; Alambic.BlockingQueue.try_dequeue(q) {true, :data}","ref":"Alambic.BlockingQueue.html#try_dequeue/1","title":"Alambic.BlockingQueue.try_dequeue/1","type":"function"},{"doc":"Try to add an item to the queue. Will never block.Exampleiex&gt; q = Alambic.BlockingQueue.create(1) iex&gt; :ok = Alambic.BlockingQueue.enqueue(q, :item) iex&gt; Alambic.BlockingQueue.try_enqueue(q, :item) false","ref":"Alambic.BlockingQueue.html#try_enqueue/2","title":"Alambic.BlockingQueue.try_enqueue/2","type":"function"},{"doc":"","ref":"Alambic.BlockingQueue.html#t:t/0","title":"Alambic.BlockingQueue.t/0","type":"type"},{"doc":"State for the blocking queue.","ref":"Alambic.BlockingQueue.State.html","title":"Alambic.BlockingQueue.State","type":"module"},{"doc":"","ref":"Alambic.BlockingQueue.State.html#t:t/0","title":"Alambic.BlockingQueue.State.t/0","type":"type"},{"doc":"A simple countdown latch implementation useful for simple fan in scenarios. It is initialized with a count and clients can wait on it to be signaled when the count reaches 0, decrement the count or increment the count.It is implemented as a GenServer.In the unlikely case you need to start a named CountDown you can directly use the GenServer.start/start_link functions passing the required initial count as argument.","ref":"Alambic.CountDown.html","title":"Alambic.CountDown","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Alambic.CountDown.html#child_spec/1","title":"Alambic.CountDown.child_spec/1","type":"function"},{"doc":"Return the current count.Exampleiex&gt; c = Alambic.CountDown.create(10) iex&gt; Alambic.CountDown.count(c) 10","ref":"Alambic.CountDown.html#count/1","title":"Alambic.CountDown.count/1","type":"function"},{"doc":"Create a CountDown object with count initial count. count must be a positive integer.Exampleiex&gt; c = Alambic.CountDown.create(2) iex&gt; is_nil(c.id) false","ref":"Alambic.CountDown.html#create/1","title":"Alambic.CountDown.create/1","type":"function"},{"doc":"Create a CountDown with count initial count. It is linked to the current process.Exampleiex&gt; c = Alambic.CountDown.create_link(2) iex&gt; Alambic.CountDown.destroy(c) :ok","ref":"Alambic.CountDown.html#create_link/1","title":"Alambic.CountDown.create_link/1","type":"function"},{"doc":"Destroy the countdown object, returning :error to all waiters.Exampleiex&gt; c = Alambic.CountDown.create(2) iex&gt; Alambic.CountDown.destroy(c) :ok","ref":"Alambic.CountDown.html#destroy/1","title":"Alambic.CountDown.destroy/1","type":"function"},{"doc":"Increase the count by one.Exampleiex&gt; c = Alambic.CountDown.create(0) iex&gt; Alambic.CountDown.increase(c) iex&gt; Alambic.CountDown.signal(c) true","ref":"Alambic.CountDown.html#increase/1","title":"Alambic.CountDown.increase/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Alambic.CountDown.html#init/1","title":"Alambic.CountDown.init/1","type":"function"},{"doc":"Reset the count to a new value.Exampleiex&gt; c = Alambic.CountDown.create(10) iex&gt; false = Alambic.CountDown.signal(c) iex&gt; Alambic.CountDown.reset(c, 1) iex&gt; Alambic.CountDown.signal(c) true","ref":"Alambic.CountDown.html#reset/2","title":"Alambic.CountDown.reset/2","type":"function"},{"doc":"Decrease the count by one. Returns true if the count reached 0, false otherwise.Exampleiex&gt; c = Alambic.CountDown.create(1) iex&gt; Alambic.CountDown.signal(c) true","ref":"Alambic.CountDown.html#signal/1","title":"Alambic.CountDown.signal/1","type":"function"},{"doc":"Wait for the count to reach 0.","ref":"Alambic.CountDown.html#wait/1","title":"Alambic.CountDown.wait/1","type":"function"},{"doc":"","ref":"Alambic.CountDown.html#t:t/0","title":"Alambic.CountDown.t/0","type":"type"},{"doc":"A simple semaphore implementation, useful when you need quick control around resource access and do not want to resort to the full OTP artillery or complex process pooling.This semaphore is implemented as a GenServer.If you need to start a named Semaphore as part of a supervision tree, you should use directly the GenServer.start/start_link functions passing the required max as argument.","ref":"Alambic.Semaphore.html","title":"Alambic.Semaphore","type":"module"},{"doc":"Acquire a slot in the semaphore. Will block until a slot is available or the semaphore is destroyed.Exampleiex&gt; s = Alambic.Semaphore.create(10) iex&gt; Alambic.Semaphore.acquire(s) :ok","ref":"Alambic.Semaphore.html#acquire/1","title":"Alambic.Semaphore.acquire/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Alambic.Semaphore.html#child_spec/1","title":"Alambic.Semaphore.child_spec/1","type":"function"},{"doc":"Create a semaphore with max slots.iex&gt; s = Alambic.Semaphore.create(3) iex&gt; is_nil(s.id) false","ref":"Alambic.Semaphore.html#create/1","title":"Alambic.Semaphore.create/1","type":"function"},{"doc":"Create a semaphore with max slots. The semaphore is linked to the current process.iex&gt; s = Alambic.Semaphore.create_link(3) iex&gt; Alambic.Semaphore.destroy(s) :ok","ref":"Alambic.Semaphore.html#create_link/1","title":"Alambic.Semaphore.create_link/1","type":"function"},{"doc":"Destroy a semaphore. Clients waiting on acquire will receive an :error response.","ref":"Alambic.Semaphore.html#destroy/1","title":"Alambic.Semaphore.destroy/1","type":"function"},{"doc":"Return true if no slot is available, false otherwise.Exampleiex&gt; s = Alambic.Semaphore.create(1) iex&gt; false = Alambic.Semaphore.full?(s) iex&gt; Alambic.Semaphore.acquire(s) iex&gt; Alambic.Semaphore.full?(s) true","ref":"Alambic.Semaphore.html#full?/1","title":"Alambic.Semaphore.full?/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Alambic.Semaphore.html#init/1","title":"Alambic.Semaphore.init/1","type":"function"},{"doc":"Release a slot from the semaphore. :error is returned if no slot is currently acquired.Exampleiex&gt; s = Alambic.Semaphore.create(1) iex&gt; Alambic.Semaphore.acquire(s) iex&gt; false = Alambic.Semaphore.try_acquire(s) iex&gt; Alambic.Semaphore.release(s) iex&gt; Alambic.Semaphore.try_acquire(s) true","ref":"Alambic.Semaphore.html#release/1","title":"Alambic.Semaphore.release/1","type":"function"},{"doc":"Try to acquire a slot in the semaphore but does not block if no slot is available. Returns true if a slot was acquired, false otherwise.Exampleiex&gt; s = Alambic.Semaphore.create(1) iex&gt; true = Alambic.Semaphore.try_acquire(s) iex&gt; Alambic.Semaphore.try_acquire(s) false","ref":"Alambic.Semaphore.html#try_acquire/1","title":"Alambic.Semaphore.try_acquire/1","type":"function"},{"doc":"","ref":"Alambic.Semaphore.html#t:t/0","title":"Alambic.Semaphore.t/0","type":"type"},{"doc":"A generic interface for &quot;waitable&quot; objects.","ref":"Alambic.Waitable.html","title":"Alambic.Waitable","type":"protocol"},{"doc":"Check if the resource is free (wait would not block)","ref":"Alambic.Waitable.html#free?/1","title":"Alambic.Waitable.free?/1","type":"function"},{"doc":"Wait for the resource to be available","ref":"Alambic.Waitable.html#wait/1","title":"Alambic.Waitable.wait/1","type":"function"},{"doc":"","ref":"Alambic.Waitable.html#t:t/0","title":"Alambic.Waitable.t/0","type":"type"}]